#include <QDateTime>
#include <QDialog>
#include <QDir>
#include <QFileIconProvider>
#include <QGroupBox>
#include <QTreeWidget>
#include <QVBoxLayout>

class MyDialog : public QDialog {
	Q_OBJECT
public:
	MyDialog(QWidget * parent = 0) : QDialog(parent) {
		// group box
		QGroupBox *gb = new QGroupBox("Group Box", this);
		QVBoxLayout *layout = new QVBoxLayout(this);
		layout->addWidget(gb);

		// tree widget
		QVBoxLayout *layoutGB = new QVBoxLayout(gb);
		QTreeWidget *tw = new QTreeWidget(this);
		layoutGB->addWidget(tw);
		tw->setFont(QFont("Courier New")); // if this is commented then it works
		tw->setHeaderLabels(QStringList() << "File Name");

		// populate tree widget
		QDir d("./");
		d.setFilter(QDir::Files | QDir::Hidden | QDir::NoSymLinks);
		d.setSorting(QDir::Name);
		QFileInfoList list = d.entryInfoList();
		QFileIconProvider iconProvider;
		for (int i = 0; i < list.count(); i++) {
			QTreeWidgetItem * tmpItem = new QTreeWidgetItem(QStringList() << list[i].fileName());
			tmpItem->setIcon(0, iconProvider.icon(list[i]));	// if this is commented then it works
			tw->addTopLevelItem(tmpItem);
		}
	}
};
